/* StartPro.c for SSP Small SmallC for Prop 	*/
/* Startup File for SSP 17.03.07 CE         	*/
/* Stack going down								*/

/* int array with index 0,2,4 because of longs  */

/* SSP - Small SmallC for Prop

this compiler compiles c-source files *.c to *.spin
ccs file	using a batch ccs

restrictions:
int and char are longs
global vars are in cog ram, registers a treated as same
division only 16 bit result
pointer variables can be used to communicate with spin

/* spin code is in #asm # endasm ====================================== */
#asm
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

VAR
	long	parameter
	long	stack[500]
	long	buffer[100]
	
PUB Start

	P_a:= 			@P_a	;Pointer Variables: Adress in Cog Ram, Variable in main ram
	P_b:=			@P_b
	P_lcount:=		@P_lcount
	
	SP := 			@stack[499]
	BP := 			@stack[499]
	BUFBAS:= 		@buffer[0]
	;C2S_Start :=	@C2S_Start
	;S2C_Start :=	@S2C_Start
	
	cognew(@asm_entry,@parameter)
	Stack[0]:=99999
	result:=SP

PUB GTBUF
	result:= BUFBAS

PUB GtC2S					; Get Pointer to Common Block C to Spin
	;result:= C2S_Start

PUB GtS2C					; Get Pointer to Common Block C to Spin
	;result:= S2C_Start


PUB GtP_a
	result:= P_a
	
PUB GtP_b
	result:= P_b	
	
PUB GtP_lcount
	result:= P_lcount

;/* ================================================================== */	

DAT
asm_entry	ORG
			JMP # Main
	
			P  long	  1;/* Primary Register */
			S  long   1;/* Second Register */
			SP long   1;/* Stack decrement before wr  */
			BP long   1;/* aux reg */
			HELP long 1;/* aux reg */
			H2 long	  1;/* aux reg */
			H3 long	  1;/* aux reg */
			CL long   1;/* aux reg */
			BUFBAS long 1	;/*start of buffer*/

; ======================================================================

mulu MOV HELP,#32	; ZAKS S 107 Multiply
	MOV H2,#0	
:mloop 	SHR S,#1 wc
	if_c ADD H2,P wc
	SHL P,#1
	DJNZ HELP,#:mloop
	MOV P,H2
mulu_ret RET	 

sign MOV H3,#0		; Find signs
	ABS P,P wc
	if_c MOV H3,#1
	ABS S,S wc
	if_c ADD H3,#1
sign_ret RET

mults 				; Signed Multiply
	CALL #sign
	CALL #mulu
	AND H3,#1 wz
	if_nz ABSNEG P,P
mults_ret RET
#endasm

/*
;==============================================================================
div3216 MOV HELP,#16	;ZKS S 126 DIVISION
	MOV H2,#0
	SHL S,#15
:dloop
	CMPSUB P,S wc,wr		; Probiere Divident-Divisor
	RCL P,#1				; Kein Unterlauf Quotient erhoehen
	DJNZ HELP,#:dloop		; Zaehler--
	
	AND P,LOW16
div3216_ret RET
*/

#asm
LOW16 long $FFFF

divu MOV HELP,#16	;ZKS S 126 DIVISION
	MOV H2,#0
	SHL S,#15
:dloop1
	CMPSUB P,S wc,wr		; Probiere Divident-Divisor
	RCL H2,#1 				; Kein Unterlauf Quotient erhoehen
	SHL P,#1					; Dividend und Quotient Links
	DJNZ HELP,#:dloop1		; Zaehler--
	
	MOV P,H2
	AND P,LOW16
divu_ret RET


divis 				; Signed Division
	CALL #sign
	CALL #divu
	AND H3,#1 wz
	if_nz ABSNEG P,P
divis_ret RET	
	
#endasm

/* ---------------------------------------- Register Definitions */
extern int ina, outa, dira, cnt, par;



/* ===================================== rd and wr of hub buffer ram*/

int adr, data;

rdbuf(i) int i;	/*-------------------------------*/
{
	adr= BUFBAS+(i<<2);
	#asm
	rdlong data,adr
	#endasm
	return(data);
}

wrbuf(d,i) int d,i; /*-------------------------------*/
{
	adr= BUFBAS+(i<<2);
	data= d;
	#asm
	wrlong data,adr
	#endasm
}


/* ===================================== delay */
int ti;

wait(aim) int aim;
{
	ti= aim;
	#asm
		waitcnt ti,#0
	#endasm
}
	
delay(ticks) int ticks;
{
	/* wait(ticks+cnt); */
	wait(cnt+ticks);
}


/* =============================================== End of StartPro.c */
